/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Eelco van Kuik.
 *
 * Contributor(s):
 *  Several developers
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
 var NEEDLESEARCH_RDFC = '@mozilla.org/rdf/container;1';
NEEDLESEARCH_RDFC = Components.classes[NEEDLESEARCH_RDFC].createInstance();
NEEDLESEARCH_RDFC = NEEDLESEARCH_RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var NEEDLESEARCH_RDFCUtils = '@mozilla.org/rdf/container-utils;1';
NEEDLESEARCH_RDFCUtils = Components.classes[NEEDLESEARCH_RDFCUtils].getService();
NEEDLESEARCH_RDFCUtils = NEEDLESEARCH_RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var NEEDLESEARCH_RDF = '@mozilla.org/rdf/rdf-service;1'
NEEDLESEARCH_RDF = Components.classes[NEEDLESEARCH_RDF].getService();
NEEDLESEARCH_RDF = NEEDLESEARCH_RDF.QueryInterface(Components.interfaces.nsIRDFService);

//NeedleSearch preferences
var NEEDLESEARCH_prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var NEEDLESEARCH_nsPref = NEEDLESEARCH_prefService.getBranch("needlesearch.");

var NEEDLESEARCH_XMLPATH = "http://www.personal-searchengines.com/rdf#"
var NEEDLESEARCH_dsource;
var NEEDLESEARCH_textelements = new Array('label','searchstring', 'method', 'encoding', 'defaultselected', 'context', 'type')
var NEEDLESEARCH_enginelist;
var NEEDLESEARCH_somethingChanged = false;
var NEEDLESEARCH_defaultselectedChecked = false;

function initSearchList()
{ 
  NEEDLESEARCH_enginelist = document.getElementById("NEEDLESEARCH_enginelist");
  var sources = NEEDLESEARCH_enginelist.database.GetDataSources();
  var rootnode = NEEDLESEARCH_RDF.GetResource("urn:needlesearch:data");
  
  flipStatus(true)
  
  var i = 0
  var dsname
  while (sources.hasMoreElements()){
    i++
    try {
      NEEDLESEARCH_dsource=sources.getNext();
      NEEDLESEARCH_dsource=NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFDataSource);
      NEEDLESEARCH_RDFC.Init(NEEDLESEARCH_dsource,rootnode);
    } catch (e) {
      NEEDLESEARCH_RDFCUtils.MakeSeq(NEEDLESEARCH_dsource,rootnode);
      NEEDLESEARCH_RDFC.Init(NEEDLESEARCH_dsource,rootnode);
    }
    
  }
  
  window.sizeToContent()
    
}

function isSomethingSelected() {
    return (NEEDLESEARCH_enginelist.selectedIndex >= 0)
    
}

function moveDelta(direction) {


    var currentNode = NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_enginelist.selectedItem.getAttribute("id"));
    var oldindex = NEEDLESEARCH_RDFC.IndexOf(currentNode); 
    var oldman = NEEDLESEARCH_enginelist.selectedIndex;
if (direction==1)
{

if (oldindex >= NEEDLESEARCH_enginelist.getRowCount())
{
exit;
}

}
   NEEDLESEARCH_RDFC.RemoveElement(currentNode,true);
    NEEDLESEARCH_RDFC.InsertElementAt(currentNode,(oldindex + direction),true);
    NEEDLESEARCH_enginelist.selectedIndex=oldman + direction;
    NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
    
}

function moveUp()
{   
    if (isSomethingSelected() && NEEDLESEARCH_enginelist.selectedIndex > 0) {
        moveDelta(-1)
    }
    return  false
}



function moveDown()
{
	if (isSomethingSelected() && NEEDLESEARCH_enginelist.selectedIndex < (NEEDLESEARCH_enginelist.getRowCount()-1)) {
        moveDelta(1)
    }
    return  false
}


function fillSpecification() {

    var selectedID = NEEDLESEARCH_enginelist.selectedItem.value
    
    alert(selectedID)
}

function populateSpecification() {
  var checked, currentCatID, context
    
    
  //check if it is not a separator
  if (isSomethingSelected()) {
      if (NEEDLESEARCH_enginelist.selectedItem.getAttribute("type") == 'item') {
          currentCatID = NEEDLESEARCH_enginelist.selectedItem.getAttribute("id");
          flipStatus(false)

          document.getElementById("searchstring").value = NEEDLESEARCH_enginelist.selectedItem.getAttribute("searchstring")
          document.getElementById("label").value = NEEDLESEARCH_enginelist.selectedItem.getAttribute("label")
          document.getElementById("encoding").value = NEEDLESEARCH_enginelist.selectedItem.getAttribute("encoding")
          document.getElementById("context").setAttribute("checked", (NEEDLESEARCH_enginelist.selectedItem.getAttribute("context") == 'true'))
          document.getElementById("method").selectedIndex = (NEEDLESEARCH_enginelist.selectedItem.getAttribute("method") == 'post')?1:0
          if (NEEDLESEARCH_enginelist.selectedItem.getAttribute("defaultselected").length > 0) {
          	  NEEDLESEARCH_defaultselectedChecked = true
	          document.getElementById("defaultselected").checked = 'checked'
	      } else {
	      	  NEEDLESEARCH_defaultselectedChecked = false
			  document.getElementById("defaultselected").checked = ''
	      }

       } else {
            flipStatus(true)
       }
  } else {
     flipStatus(true)
  }
  
  return false;
  
}

function doAction() {
    var action = document.getElementById('actionslist').value
    
    if (action == 'add') {
        addItem('')
    }
    
    if (action == 'remove') {
        removeItem()
    }
    
    if (action == 'separator') {
            addItem('separator')
    }
    
    return false;

}

function addItem(which)
{
  
  flipStatus(true)
  
  var type, label
  
  switch (which) {
    case 'separator':
        label = '---------'
        type = 'separator'
    break
    default:
        label = 'New item'
        type = 'item'
    break
  }
  
  var insertposition = (NEEDLESEARCH_enginelist.selectedIndex + 1)
  if (insertposition < 1) {
    insertposition = NEEDLESEARCH_RDFC.GetCount() + 1
  }
  
  var newnode=NEEDLESEARCH_RDF.GetAnonymousResource ();
  
  var property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + "label");
  var newvalue=NEEDLESEARCH_RDF.GetLiteral(label);
  NEEDLESEARCH_dsource.Assert(newnode,property,newvalue,true);
  
  property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + "type");
  newvalue=NEEDLESEARCH_RDF.GetLiteral(type);
  NEEDLESEARCH_dsource.Assert(newnode,property,newvalue,true);
  
  NEEDLESEARCH_RDFC.InsertElementAt(newnode,insertposition,true);
  
  
  
  NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
  
  return false;
}

function removeItem() {
    var currentNode, property, removevalue
    var theItem = NEEDLESEARCH_enginelist.selectedItem
    if (isSomethingSelected()) {
    	currentNode = NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_enginelist.selectedItem.getAttribute("id"));

	remvals = new Array()
	    for (i = 0; i < NEEDLESEARCH_textelements.length; i++) {
	        //dump("De waarde van " + NEEDLESEARCH_textelements[i] + " is: " +theItem.getAttribute(NEEDLESEARCH_textelements[i]) + "\n")
    		remvals[i] = [new String(NEEDLESEARCH_textelements[i]), new String(theItem.getAttribute(NEEDLESEARCH_textelements[i]))]
        }

        for (i = 0; i < remvals.length; i++) {
	        //dump("De waarde van " + remvals[i][0] + " is: " + remvals[i][1] + "\n")
            try {
	            property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + NEEDLESEARCH_textelements[i]);
	            removevalue=NEEDLESEARCH_RDF.GetLiteral(theItem.getAttribute(NEEDLESEARCH_textelements[i]));
	            NEEDLESEARCH_dsource.Unassert(currentNode, property, removevalue, true);
	        } catch (err) {
	        	dump("Error in removeItem (1): " + err)
	        }
        }
		
		try {
	        NEEDLESEARCH_RDFC.RemoveElement(currentNode,true);
	        NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
        } catch (err) {
        	dump("Error in removeItem (2): " + err)
        }

    }
	
	//dump("------------------------------------------\n\n")
	    
    flipStatus(true)
}

function saveChanges() {
  
  var target, newvalue, oldvalue, doInsert, tmpcurrentNode
  doInsert = false
  var maxpositionnode = NEEDLESEARCH_RDFC.GetCount()
  if (isSomethingSelected()) {
      var currentNode       = NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_enginelist.selectedItem.getAttribute("id"));

       if (document.getElementById('searchstring').value.indexOf('NeedleSearch') < 0) {
            doInsert = confirm(document.getElementById('needlesearch_properties').getString('ed.add_error'))
       } else {
            doInsert = true
       }

       if (doInsert) {
          //All the text elements
          for (i = 0; i < NEEDLESEARCH_textelements.length; i++) {
	          if (NEEDLESEARCH_textelements[i] == 'defaultselected') {
	          	  if (document.getElementById(NEEDLESEARCH_textelements[i]).checked) {
	          	  	if (!NEEDLESEARCH_defaultselectedChecked) {
	          	  	  //This option was previously not selected
		              for (var j = 0; j < NEEDLESEARCH_enginelist.getRowCount(); j++) {
		              	//getRowCount is unreliable...
		              	try {
			              	if (NEEDLESEARCH_enginelist.getItemAtIndex(j)) {
			              		if (NEEDLESEARCH_enginelist.getItemAtIndex(j).getAttribute(NEEDLESEARCH_textelements[i]) == 'true') {
			              		  tmpcurrentNode = NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_enginelist.getItemAtIndex(j).getAttribute("id"));
				              	  target=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + NEEDLESEARCH_textelements[i]);
						          oldvalue=NEEDLESEARCH_RDF.GetLiteral(NEEDLESEARCH_enginelist.getItemAtIndex(j).getAttribute(NEEDLESEARCH_textelements[i]));
						          NEEDLESEARCH_dsource.Unassert(tmpcurrentNode, target, oldvalue, true);
						          NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
					          }
			              	}
			              } catch (err) {
			                //Break out of the loop
			              	j = NEEDLESEARCH_enginelist.getRowCount()
			              }
		              }

		          	  target = NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + NEEDLESEARCH_textelements[i]);
		              newvalue=NEEDLESEARCH_RDF.GetLiteral('true');
		              oldvalue = NEEDLESEARCH_RDF.GetLiteral(NEEDLESEARCH_enginelist.selectedItem.getAttribute(NEEDLESEARCH_textelements[i]))
		              NEEDLESEARCH_dsource.Change(currentNode, target, oldvalue, newvalue);
		              
		              try {
			              //Put it in pref for backup because of bug #207888
			              //NEEDLESEARCH_nsPref.clearUserPref('DefaultSelected')
						  NEEDLESEARCH_nsPref.setIntPref('DefaultSelected', NEEDLESEARCH_enginelist.selectedIndex)
					  } catch (err) {}
		            } 
	          	  } else {
	          	      target=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + NEEDLESEARCH_textelements[i]);
			          oldvalue=NEEDLESEARCH_RDF.GetLiteral(NEEDLESEARCH_enginelist.selectedItem.getAttribute(NEEDLESEARCH_textelements[i]));
			          NEEDLESEARCH_dsource.Unassert(currentNode, target, oldvalue, true);
			      }
	          } else if (document.getElementById(NEEDLESEARCH_textelements[i]).nodeName == 'checkbox') { 
				  if (document.getElementById(NEEDLESEARCH_textelements[i]).checked) {
				  	//Insert entry when checked
	          	  	  target = NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + NEEDLESEARCH_textelements[i]);
		              newvalue=NEEDLESEARCH_RDF.GetLiteral('true');
		              oldvalue = NEEDLESEARCH_RDF.GetLiteral(NEEDLESEARCH_enginelist.selectedItem.getAttribute(NEEDLESEARCH_textelements[i]))
		              NEEDLESEARCH_dsource.Change(currentNode, target, oldvalue, newvalue);
	          	  } else {
	          	  	//Remove entry when unchecked
	          	      target=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + NEEDLESEARCH_textelements[i]);
			          oldvalue=NEEDLESEARCH_RDF.GetLiteral(NEEDLESEARCH_enginelist.selectedItem.getAttribute(NEEDLESEARCH_textelements[i]));
			          NEEDLESEARCH_dsource.Unassert(currentNode, target, oldvalue, true);
			      }
	          
	          
	          } else {
	              target = NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + NEEDLESEARCH_textelements[i]);
	              newvalue=NEEDLESEARCH_RDF.GetLiteral(document.getElementById(NEEDLESEARCH_textelements[i]).value);
	              oldvalue = NEEDLESEARCH_RDF.GetLiteral(NEEDLESEARCH_enginelist.selectedItem.getAttribute(NEEDLESEARCH_textelements[i]))
	              NEEDLESEARCH_dsource.Change(currentNode, target, oldvalue, newvalue);
              }
          }

          NEEDLESEARCH_somethingChanged = false
       }

      NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
  }
}

function closeEditorWindow() {
    
    if (NEEDLESEARCH_somethingChanged && confirm(document.getElementById('needlesearch_properties').getString('ed.savechanges'))) {
        saveChanges()
    }
    self.close()
    return false
}

function flipStatus(newstatus) {
      
      document.getElementById('PreferencesButton').disabled = newstatus
      
      for (i = 0; i < NEEDLESEARCH_textelements.length; i++) {
          if (document.getElementById(NEEDLESEARCH_textelements[i])) {
          	
          	if (document.getElementById(NEEDLESEARCH_textelements[i]).nodeName == 'checkbox') {
          		document.getElementById(NEEDLESEARCH_textelements[i]).checked = ''
          	} else {
	          	document.getElementById(NEEDLESEARCH_textelements[i]).value = ''
	        }
			
			document.getElementById(NEEDLESEARCH_textelements[i]).disabled = newstatus
	      }
      }  
      
    return false;
}
