/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Eelco van Kuik.
 *
 * Contributor(s):
 *  Several developers
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var NEEDLESEARCH_RDFC = '@mozilla.org/rdf/container;1';
NEEDLESEARCH_RDFC = Components.classes[NEEDLESEARCH_RDFC].createInstance();
NEEDLESEARCH_RDFC = NEEDLESEARCH_RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var NEEDLESEARCH_RDFCUtils = '@mozilla.org/rdf/container-utils;1';
NEEDLESEARCH_RDFCUtils = Components.classes[NEEDLESEARCH_RDFCUtils].getService();
NEEDLESEARCH_RDFCUtils = NEEDLESEARCH_RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var NEEDLESEARCH_RDF = '@mozilla.org/rdf/rdf-service;1'
NEEDLESEARCH_RDF = Components.classes[NEEDLESEARCH_RDF].getService();
NEEDLESEARCH_RDF = NEEDLESEARCH_RDF.QueryInterface(Components.interfaces.nsIRDFService);

// Search component
var NEEDLESEARCH_gFinder = Components.classes["@mozilla.org/embedcomp/rangefind;1"].createInstance().QueryInterface(Components.interfaces.nsIFind);

//NeedleSearch preferences
var NEEDLESEARCH_prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var NEEDLESEARCH_nsPref = NEEDLESEARCH_prefService.getBranch("needlesearch.");
var NEEDLESEARCH_nsTextOnly
var NEEDLESEARCH_nsToolbarHeight

// Is the highlight active ?
var NEEDLESEARCH_gbHighlightOn = false;
// What was the term used for the highlighting ?
var NEEDLESEARCH_gHighlightString = "";

var NEEDLESEARCH_FORMDRILLER = false;
var NEEDLESEARCH_XMLPATH = "http://www.personal-searchengines.com/rdf#"
var NEEDLESEARCH_dsource;

var NS = new NeedleSearch()
var AA = new AutoAdder()

function NeedleSearch () {

    this.initSearchList = NeedleSearch_initSearchList
    this.DisplayCheck = NeedleSearch_DisplayCheck
    this.captureEvent = NeedleSearch_captureEvent
    this.showOrHideMe = NeedleSearch_showOrHideMe
    this.ClearTerms = NeedleSearch_ClearTerms
    this.addTerm = NeedleSearch_addTerm
    this.FindInPage = NeedleSearch_FindInPage
    this.HighLightInPage = NeedleSearch_HighLightInPage
    this.changeImage = NeedleSearch_changeImage
    this.imgflip = imgflip
	/**
	 *	public initContext() initializes the context menu
	 *
	 *@author Eelco van Kuik
	 */

	this.init = function init() {
		//Set preferred height
		try {
			NEEDLESEARCH_nsToolbarHeight = NEEDLESEARCH_nsPref.getCharPref('ToolbarHeight')
		} catch (err) {
			NEEDLESEARCH_nsToolbarHeight = 30
		}
		
		document.getElementById('ToolbarHeight').height = NEEDLESEARCH_nsToolbarHeight
		
		//set default engine if XUL doesn't work
		var engineList = document.getElementById('NeedleSearchMenulist')
		if (engineList.selectedIndex <=0) {
			engineList.selectedIndex = defaultSelected()
		}
		
		//set context items right
		nukeimages()
		setContextItem('ShowButton')		
		setContextItem('ShowNewTabButton')
		setContextItem('ShowNewWindowButton')
		syncPref('SearchInPage')
		setContextItem('HighlightButton')
		setContextItem('AutoAddButton')
		setContextItem('EditorButton')
		setContextItem('NeedleSearchUrlButton')
	}


	/**
	 *	private setContextItem() checks or uncheckes individual context items
	 *
	 *@author Eelco van Kuik
	 */

	function setContextItem(itemID) {
		var buttonHidden = document.getElementById(itemID).getAttribute("hidden")
		document.getElementById(itemID + '-Context').setAttribute("checked", (buttonHidden != 'true'))		
	}

	this.searchContext = function searchContext(theObject) {
		//This should go in pref window
		var searchstring = theObject.getAttribute("searchstring")
		var encoding = theObject.getAttribute("encoding")
		var method = theObject.getAttribute("method")
		
		var target
		try {
			target = NEEDLESEARCH_nsPref.getCharPref('contextTarget')
		} catch(err) {
			target = '_blank'
		}


		var searchterms = getSelectedText()
		search(target, searchterms, searchstring, method, encoding)
		
	}

	this.searchBar = function searchBar(target) {
		var method, encoding, searchstring, searchterms
	    var engineList = document.getElementById('NeedleSearchMenulist')
		searchterms = document.getElementById('NeedleSearchSearchTerms').value
		method = engineList.selectedItem.getAttribute("method")
	    encoding = engineList.selectedItem.getAttribute("encoding")
	    searchstring = engineList.selectedItem.getAttribute("searchstring")
	    searchterms = document.getElementById('NeedleSearchSearchTerms').value
		
		NeedleSearch_addSearchstring(searchterms)
		
		search(target, searchterms, searchstring, method, encoding)
	}
	
	function defaultSelected() {
		var prefVal
		try { 
			prefVal = (NEEDLESEARCH_nsPref.getIntPref('DefaultSelected') + 1)
		} catch (err) {
			//Pref doesn't exist, just get the first then
			prefVal = 1
		}
		return prefVal
	
	}
	
	function search(target, searchterms, searchstring, method, encoding) {
		
	    	
		if (searchstring.length > 0) {
		//Is a searchengine selected?
	
			if (target == 'newtab'){
				//For a new tab
				var newTab = getBrowser().addTab('about:blank', getReferrer(document));
				getBrowser().selectedTab = newTab
				NeedleSearch_createForm(searchterms, searchstring, method, encoding, "_top")
			} else {
				//For a new window and same window
				try {
					NeedleSearch_createForm(searchterms, searchstring, method, encoding, target)
				} catch(er) {
					//If content is i.e. xml
					window._content.location='about:blank'
					NeedleSearch_wait("NeedleSearch_createForm('" + searchterms + "','" + searchstring + "','" + method + "','" + encoding + "','" +  target + "')", target)
				}
			}
	
		} else {
			alert(document.getElementById('needlesearch_properties').getString('ns.no_engine_error'))
			document.getElementById('NeedleSearchMenulist').focus()
		}
	    
	    return false;
	    
	}
	
	function syncPref(itemID) {
		var prefVal
		try { 
			prefVal = NEEDLESEARCH_nsPref.getBoolPref(itemID)
		} catch (err) {
			//Pref doesn't exist
			NEEDLESEARCH_nsPref.setBoolPref(itemID, true)
			prefVal = NEEDLESEARCH_nsPref.getBoolPref(itemID)
		}
		document.getElementById(itemID + '-Context').setAttribute("checked", prefVal)
	}
	
	this.changePref = function changePref(theEvent) {
		var item = theEvent.target
		NEEDLESEARCH_nsPref.setBoolPref('SearchInPage', (item.getAttribute("checked") == "true"))
	}


}

/**
*	Utils
*
*/

function getSelectedText() {

   var focusedWindow = document.commandDispatcher.focusedWindow;
   var selection = focusedWindow.__proto__.getSelection.call(focusedWindow);
   selection = NeedleSearch_TrimString(String(selection));
   return selection;

}



function NeedleSearch_isIn(arr, str)
{
    for(var i=0; i<arr.length; i++)
    {
        if(arr[i].toLowerCase() == NeedleSearch_TrimString(str.toLowerCase()))
            return true;
    }
    return false;
}

function NeedleSearch_TrimString(theString)
{
    if (!theString) return "";
    return theString.replace(/(^\s+|\s+$)/g, '')
}


function NeedleSearch_initSearchList()
{ 
  var sources = document.getElementById('NeedleSearchMenupopup').database.GetDataSources();
  var rootnode = NEEDLESEARCH_RDF.GetResource("urn:needlesearch:data");
  
  var i = 0
  var dsname
  while (sources.hasMoreElements()){
    i++
    try {
      NEEDLESEARCH_dsource=sources.getNext();
      NEEDLESEARCH_dsource=NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFDataSource);
      NEEDLESEARCH_RDFC.Init(NEEDLESEARCH_dsource,rootnode);
    } catch (e) {
      NEEDLESEARCH_RDFCUtils.MakeSeq(NEEDLESEARCH_dsource,rootnode);
      NEEDLESEARCH_RDFC.Init(NEEDLESEARCH_dsource,rootnode);
    }
    
  }
    
}


/**
 *	function HideItem(event)
 *
 *  Takes care of hiding and/or showing the buttons on the bar
 *
 *
 *  @author Eelco van Kuik
 */

function NeedleSearch_HideItem(event) {
    var item = event.target;
    var theButton;
	theButton = document.getElementById(item.getAttribute("id").replace("-Context",''));
	theButton.setAttribute("hidden",!item.getAttribute("checked"));
	
}

function NeedleSearch_DisplayCheck() {

  var main = document.getElementById("main-window");
  var needlesearch = document.getElementById("needlesearch");
  needlesearch.setAttribute("collapsed", "false");     
  if (main.hasAttribute("chromehidden") && (needlesearch != null)) {
    if (main.getAttribute("chromehidden").indexOf("location") != -1) {
      needlesearch.setAttribute("collapsed", "true");     
    }
  }
  
}


function NeedleSearch_wait(expression, target) {
	
	if (!window._content.document.body) {
		setTimeout('NeedleSearch_wait(' + expression + ',\'' + target + '\')', 10)	
	} else {
		eval(expression)
		if (target == '_blank') {
    		window._content.history.go(-1)
    	}
	}

}

/**
*
*	Virtual Forms
*/

function NeedleSearch_createForm(searchterms, searchstring, method, encoding, target) {
    var theDocument = window._content.document
    var is_multifieldsearch = false
	
	//Older NeedleSearch users might not have this in their list   
    if (!encoding) {
    	encoding = 'UTF-8'
    }
    
    if (!method) {
    	method = 'get'
    }
	
	var splitString = NeedleSearch_getSplitString()
	/**
	*	A search is a multifieldsearch when:
	*	1. The search terms contain the split string (see preferences)
	*   2. The url contains the NeedleSearch1, NeedleSearch2, etc.
	*
	*/

	//REm = multifield string
	//REs = single field string
	REm = new RegExp("NeedleSearch[0-9]+", "gi")
	REs = new RegExp("NeedleSearch", "gi")

	if (searchterms.indexOf(splitString) > -1 && REm.test(searchstring)) {
		is_multifieldsearch = true
	}
	
	//Replace all occurrences
	if (is_multifieldsearch) {
		searchterms = searchterms.split(splitString)
		for (var i = 0; i < searchterms.length; i++) {
			REtemp = new RegExp("needlesearch" + (i+1),"gi")
			searchstring = searchstring.replace(REtemp, searchterms[i])
		}
	} else {
		searchstring = searchstring.replace(REs, searchterms)
		
	}

	//Create a virtual form
    var bodyObj = theDocument.body
    var formObj = theDocument.createElement('form');
    bodyObj.appendChild(formObj)
	
    formObj.setAttribute("name", "NeedleSearch_VirtualForm")
    formObj.setAttribute("id", "NeedleSearch_VirtualForm")
	formObj.setAttribute("accept-charset", encoding)
	formObj.setAttribute("method", method)
	formObj.setAttribute("target", target)
    
   	var REurl = /&url=(.*)[?]*/;
   	var action = NeedleSearch_renderAction(searchstring, searchterms, is_multifieldsearch)
	formObj.setAttribute("action", action)
	
	var matches = NeedleSearch_getElements(searchstring)
	var tmpInput
	for (var i=0; i < matches.length; i++) {
		tmpInput = NeedleSearch_createInput(matches[i], theDocument, searchterms, splitString)
		if (tmpInput) {
			formObj.appendChild(tmpInput)
		}
	}
	theDocument.close()	
	formObj.submit()
	return false;
}

function NeedleSearch_getSplitString() {
	var splitString
	try {
		splitString = NEEDLESEARCH_nsPref.getCharPref('multiFieldSplitter')
	} catch (err) {
		//default value
		splitString = ';'
	}
	return splitString
}

function NeedleSearch_getBodyElement(theDocument) {
	var firstChild = theDocument.childNodes.length
	var firstElement
	for (var i = 0; i < firstChild; i++) {
	firstElement = theDocument.childNodes[1].childNodes[0]
	}
	return something
}

function NeedleSearch_getElements(theUrl) {
	var formElements
	var matches = []
	if (theUrl.indexOf('?') > -1) {
		var elmnts = theUrl.substring(theUrl.indexOf('?') + 1, theUrl.length)
		matches = elmnts.split('&')
	}
	return matches		
}


function NeedleSearch_createInput(nameAndValue, theDocument, searchterms, splitString) {
		var tmpVal
		var arrNameAndValue = nameAndValue.split('=')
		var inputObj = theDocument.createElement('input');
		inputObj.setAttribute("type", "hidden")
		var name
		if (arrNameAndValue[0] == 'submit') {
			//For some reason a formelement can't be called: submit,
			// otherwise form.submit() gives an error..!
			name = 'submit2'
		} else {
			name = arrNameAndValue[0]
		}
		
		inputObj.setAttribute("name", name)

		if (arrNameAndValue.length > 1) {
			//Unfortunately there is no unescape with other decondings then ISO-8859-1
			try {
			//This crashes on special characters
				tmpVal = unescape(arrNameAndValue[1])
				tmpVal = tmpVal.replace(/[+]{1}/g,' ')
			} catch(err) {
				tmpVal = arrNameAndValue[1]
			}
			inputObj.setAttribute("value", tmpVal)
		}
		
		return inputObj
		
}

function NeedleSearch_renderAction(theUrl, searchterms, splitString, is_multifieldsearch)	 {
		var newUrl
		var RE = /NeedleSearch[0-9]+/gi
		
		if (theUrl.indexOf('?') > -1) {
			newUrl = theUrl.substring(0,(theUrl.indexOf('?')))	
		} else {
			newUrl = theUrl
		}
		
		return newUrl			

}

function NeedleSearch_addSearchstring(searchterms) {
	var NSsearchterms = document.getElementById('NeedleSearchSearchTerms')
	NSsearchterms.insertItemAt(0,searchterms,searchterms)
	try {
		NSsearchterms.removeItemAt(20)
	} catch(er) {
		//do nothing
	}
	
}

function NeedleSearch_ClearTerms() {
   var termBox = document.getElementById("NeedleSearchSearchterms");
   for(var numTerms=termBox.childNodes.length; numTerms > 0; numTerms--) {
      termBox.removeChild(termBox.childNodes[0]);
   }        
}

function NeedleSearch_addTerm(term) {

    var critBox = document.getElementById("googlebarCriteria");
	var mySearchTermBox = document.getElementById("NeedleSearchSearchterms");
	var myTerms = NeedleSearch_FindTerms(term);     
	var tempNode;
	for(var i=0;i<myTerms.length;i++) {
		tempNode = document.createElement("button");
		tempNode.setAttribute("label", myTerms[i]);
		tempNode.className = "NeedleSearchSearchterms";
		tempNode.setAttribute("oncommand", "NS.FindInPage('" + myTerms[i] + "')");
		tempNode.setAttribute("tooltiptext", document.getElementById('needlesearch_properties').getString('ns.searchInPage1_tt') + " \"" + myTerms[i] + "\" " + document.getElementById('needlesearch_properties').getString('ns.searchInPage2_tt'));
	if (NEEDLESEARCH_nsTextOnly !="true") {
		tempNode.setAttribute("image", "chrome://needlesearch/content/img/term.gif");
		tempNode.setAttribute("onmouseover", "this.setAttribute('image', 'chrome://needlesearch/content/img/term_over.gif')");
		tempNode.setAttribute("onmouseout", "this.setAttribute('image', 'chrome://needlesearch/content/img/term.gif')");
	} else {
		tempNode.setAttribute("label", "[" + myTerms[i] + "]");
	}
		tempNode.setAttribute("orient", "horizontal");
		tempNode.setAttribute("crop", "end");
		mySearchTermBox.appendChild(tempNode);
	}
 
}

function NeedleSearch_FindInPage(str) {
    
    var focusedWindow = document.commandDispatcher.focusedWindow;
    if (!focusedWindow || focusedWindow == window)
        focusedWindow = window._content;
    
    var findInst = gBrowser.webBrowserFind;
    var findInFrames = findInst.QueryInterface(Components.interfaces.nsIWebBrowserFindInFrames);
    findInFrames.rootSearchFrame = _content;
    findInFrames.currentSearchFrame = focusedWindow;
    
    var findService = Components.classes["@mozilla.org/find/find_service;1"]
            .getService(Components.interfaces.nsIFindService);
    findInst.searchString  = str;
    findInst.matchCase     = findService.matchCase;
    findInst.wrapFind      = true;
    findInst.entireWord    = findService.entireWord;
    findInst.findBackwards = false;
    
    var searchResult = findInst.findNext();
    
    if(!searchResult) {
        alert(str +' ' + document.getElementById('needlesearch_properties').getString('ns.str_not_found'))
    }

}


function NeedleSearch_FindTerms(criteria) {
   // quotes only matter when preceded by a space or a quote.
   var terms = new Array();
   
   var splitStr = NeedleSearch_getSplitString();
   criteria = criteria.replace(splitStr, ' ')

   var inQuote = false;
   var haveTerm = false;

   var index = 0;       // our current pointer
   var currPtr = 0; // the start of the current term
   var prevChar = ' ';  // the char we last saw

   while (index < criteria.length) {
      var currChar = criteria.charAt(index);

      switch (currChar) {
      case ' ':
         if (!inQuote && haveTerm) {
               var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
               if (!NeedleSearch_isIn(terms, val))
                   terms.push(val);
            haveTerm = false;
         }
         break;
      case '"':
         if (!inQuote) {
            if (haveTerm) {
               var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
               if (!NeedleSearch_isIn(terms, val))
                   terms.push(val);
               haveTerm = false;
            }

        if ((prevChar == ' ') || (prevChar == '"')) {
               inQuote = true;
            }
         } else {
            if (haveTerm) {
               var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
               if (!NeedleSearch_isIn(terms, val))
                   terms.push(val);
               haveTerm = false;
               inQuote = false;
            }
         }
         break;
      default:
         if (!haveTerm) {
            haveTerm = true;
            currPtr = index;
         }
      }
      prevChar = currChar;
      index++;
   }
   var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
   if (haveTerm && !NeedleSearch_isIn(terms, val) ) {
      terms.push(val);
   }
   
   return terms;
}

function NeedleSearch_changeImage(theObj, theEvent) {
	var theImageUrl = theObj.getAttribute('image')
	var RE = /red.*[.]+gif/
	if (RE.test(theImageUrl)) {
		//present image is the green image
		if (theEvent == 'over') {
			//onmouseover event
			theObj.setAttribute('image', "chrome://needlesearch/content/img/red_over.gif")
		} else {
			//onmouseout event
			theObj.setAttribute('image', "chrome://needlesearch/content/img/red.gif")
		}
	} 

}

/**
 * AutoAdder()
 * This class contains all functionality of the Auto-Add option
 * 
 * @author Eelco van Kuik
 */

function AutoAdder() {
	
	var NeedleSearchProgressListener = {
	  onProgressChange: function ProgressChange(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	
	  onStateChange: function StateChange(aWebProgress, aRequest, aStateFlags, aStatus) {},
	
	  onLocationChange: function LocationChange(aWebProgress, aRequest, aLocation) {
	    var domWindow = aWebProgress.DOMWindow;
	    grabURL(aLocation)
	    
	  },
	
	  onStatusChange: function StatusChange(aWebProgress, aRequest, aStatus, aMessage) {},
	
	  onSecurityChange: function SecurityChange(aWebProgress, aRequest, aState) {},
	
	  QueryInterface: function QueryInterface(aIID) {
	    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
	        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
	        aIID.equals(Components.interfaces.nsISupports))
	      return this;
	    throw Components.results.NS_NOINTERFACE;
	  }
	};
	
	
	/**
	 * public start()
	 * 
	 * This method starts the Auto-adder.
	 * 
	 * @author Eelco van Kuik
	 */
	
	this.start = function start() {
	    var total;
	    var startWin = window._content
		var bundle = document.getElementById('needlesearch_properties');
	    
	    if (!NEEDLESEARCH_FORMDRILLER) {
	    	changeAction(startWin)
	        NEEDLESEARCH_FORMDRILLER = true
	        getBrowser().addProgressListener(NeedleSearchProgressListener);
		if (NEEDLESEARCH_nsTextOnly == "true" ) 
		{
	        	document.getElementById('AutoAddButton').setAttribute("label",bundle.getString('ns.noimage_autoadd_active'));	
		} else {
		        document.getElementById('AutoAddButton').setAttribute("image", "chrome://needlesearch/content/img/glow.gif")
		}        

	    } else {
	    	//switch it off
	if (NEEDLESEARCH_nsTextOnly == "true" ) 
		{
	        	document.getElementById('AutoAddButton').setAttribute("label",bundle.getString('ns.noimage_autoadd'));	
		} else {
	   	    document.getElementById('AutoAddButton').setAttribute("image", "chrome://needlesearch/content/img/red.gif")
		}        
		getBrowser().removeProgressListener(NeedleSearchProgressListener);
	    	NEEDLESEARCH_FORMDRILLER = false
	    }
	    
	    return false
	}
	
	
	/**
	 * 
	 * private changeAction()
	 * 
	 * Changes the action to get. Adds an extra field called: "NeedleSearch_postMethod"
	 * that contains the previous method.
	 * 
	 * @author Eelco van Kuik
	 */
	
	function changeAction(theWindow) {
	    
	    var theForms
	    if (theWindow.document && theWindow.document.forms) {
	        for (var i = 0; i < theWindow.document.forms.length; ++i) {
		        
		        try {
			        //Send old method with it
		            if (theWindow.document.forms[i].method == 'post') {
		            	//It was posted
			            var inputObj = window._content.document.createElement("input")
			        	inputObj.setAttribute("name","NeedleSearch_postMethod")
			        	inputObj.setAttribute("type","hidden")
		            	theWindow.document.forms[i].appendChild(inputObj)            	
		            }
		            theWindow.document.forms[i].method="get";
				} catch(err) {
					//If this failed, let's hope the form is in another window..
				}
	
		    }
		    //Now check if there are more frames in this window
		    if (theWindow.frames) {    
		        for (var j=0; j < theWindow.frames.length; j++) {
		           changeAction(theWindow.frames[j])
		        }
		    }
		}
	}
	
	/**
	 * private grabURL()
	 * 
	 * grabs the URL of the window
	 * @author Eelco van Kuik
	 */
	
	function grabURL(aLocation) {
	    var win = window._content.document
	    var newurl = aLocation.prePath + aLocation.path
	    var method = getMethod(newurl)
	    newurl = getStrippedUrl(newurl)
	    var encoding = win.characterSet
	    
	    if (newurl.indexOf('NeedleSearch') > 0) {
	        finish(aLocation.host, newurl, method, encoding)
	    } else {
	        alert(document.getElementById('needlesearch_properties').getString('ns.autoadd_error'))
	    }
	    
	    document.getElementById('AutoAddButton').setAttribute("image", "chrome://needlesearch/content/img/red.gif")
	    getBrowser().removeProgressListener(NeedleSearchProgressListener);
	    NEEDLESEARCH_FORMDRILLER = false
	    win.close()
	}
	
	
	/**
	 * private getMethod
	 * 
	 * Gets the method from the url, depending on wether or not it contains the variable
	 * called: "NeedleSearch_postMethod"
	 * 
	 * @author Eelco van Kuik
	 */
	
	function getMethod(theSearchstring) {
		var RE = /[&|?]+NeedleSearch_postMethod=/
		var method
		if (RE.test(theSearchstring)) {
			return 'post'
		} else {
			return 'get'
		}
	}
	
	/**
	 * private getStrippedUrl()
	 * 
	 * Strips the URL of the unecessary variable: "NeedleSearch_postMethod"
	 * 
	 * @author Eelco van Kuik
	 */
	
	function getStrippedUrl(theSearchstring) {
		var win = window._content.document
		var RE = /[&|?]+NeedleSearch_postMethod=/
		return theSearchstring.replace(RE,'')
	}
	
	/**
	 * private finish()
	 * 
	 * Adds the form to the rdf file
	 * 
	 * @author Eelco van Kuik
	 */

	function finish(aHost, theNewurl, method, encoding) {   
	    
	    //Get a label for the new entry, let the user fill it in.
	    var label = aHost
	    label = prompt(document.getElementById('needlesearch_properties').getString('ns.autoadd_prompt'), aHost)
	    
	    if (typeof(label) == 'object' || label.replace(/^\s+|\s+$/, '') == '') {
	    	label = aHost
	    }
		
		var type = 'item'
	    var insertposition = NEEDLESEARCH_RDFC.GetCount() + 1
	    var newnode=NEEDLESEARCH_RDF.GetAnonymousResource ();
	    var property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + "label");
	    var newvalue=NEEDLESEARCH_RDF.GetLiteral(label);
	
	    NEEDLESEARCH_dsource.Assert(newnode,property,newvalue,true);
	
	    property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + "type");
	    newvalue=NEEDLESEARCH_RDF.GetLiteral(type);
	    NEEDLESEARCH_dsource.Assert(newnode,property,newvalue,true);
	
	    property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + "searchstring");
	    newvalue=NEEDLESEARCH_RDF.GetLiteral(theNewurl);
	    NEEDLESEARCH_dsource.Assert(newnode,property,newvalue,true);
	
	    property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + "encoding");
	    newvalue=NEEDLESEARCH_RDF.GetLiteral(encoding);
	    NEEDLESEARCH_dsource.Assert(newnode,property,newvalue,true);
	
	    property=NEEDLESEARCH_RDF.GetResource(NEEDLESEARCH_XMLPATH + "method");
	    newvalue=NEEDLESEARCH_RDF.GetLiteral(method);
	    NEEDLESEARCH_dsource.Assert(newnode,property,newvalue,true);
	
	    NEEDLESEARCH_RDFC.InsertElementAt(newnode,insertposition,true);
	    NEEDLESEARCH_dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
	
	    alert(document.getElementById('needlesearch_properties').getString('ns.autoadd_succes') + label)
	    return false;
	  
	}
	
}
function NeedleSearch_captureEvent (event) {
        if (event.keyCode == 13 && event.shiftKey) {
                return NS.searchBar('_blank')
        }

        if (event.keyCode == 13 && event.ctrlKey) {
                return NS.searchBar('newtab')
        }

        if(event.keyCode == 13) {
                return NS.searchBar('_top')
        }

}

function NeedleSearch_showOrHideMe(which) {
        var current_state = document.getElementById(which + '-Context').getAttribute('checked');
        if (current_state = true) {
                document.getElementById(which).hidden = true
        } else {
                document.getElementById(which).setAttribute(!document.getElementById('which').getAttribute("checked"))
        }

}

function NeedleSearch_HighLightInPage() {
    // Initialize to current document
    var gTheDocument = window._content.document;

    var termColor = new Array("yellow", "lightpink", "aquamarine", "darkgoldenrod", "darkseagreen", "lightgreen", "rosybrown", "seagreen", "chocolate", "violet");
    var critBox = document.getElementById("NeedleSearchSearchTerms");
    var term = critBox.value;

    if (NEEDLESEARCH_gbHighlightOn)
    {
        NEEDLESEARCH_gbHighlightOn = false;
        highlightDoc(null, null);
        if (NEEDLESEARCH_gHighlightString == term)
            return;
    }

    NEEDLESEARCH_gbHighlightOn = true;
    NEEDLESEARCH_gHighlightString = term;

    var myTerms = NeedleSearch_FindTerms(term);
    for (var i = 0; i < myTerms.length; i++) {
        dump("Highlight " + myTerms[i] + "\n");

        highlightDoc(myTerms[i], termColor[i %10]);
    }
}

function highlightDoc(word, color, win)
{
    if (!win)
        win = window._content;

    for (var i=0; win.frames && i<win.frames.length; i++)
    {
        highlightDoc(word, color, win.frames[i]);
    }

    var doc = win.document;
    if(!document)
        return;

    // Remove highligthing
    if (!color)
    {
        var elem = null;
        while (elem = doc.getElementById("NeedleSearch-search-id"))
        {
            var child = null;
            var docfrag = doc.createDocumentFragment();
            var next = elem.nextSibling;
            var parent = elem.parentNode;
            while(child = elem.firstChild)
                docfrag.appendChild(child);
            parent.removeChild(elem);
            parent.insertBefore(docfrag, next);
        }
        return;
    }


    var body = doc.body;
    if (!body)
        return;
    var count = body.childNodes.length;

    searchRange = doc.createRange();
    startPt = doc.createRange();
    endPt = doc.createRange();

    var baseNode = doc.createElement("span");
    baseNode.setAttribute("style", "background-color: " + color + ";");
    baseNode.setAttribute("id", "NeedleSearch-search-id");

    searchRange.setStart(body, 0);
    searchRange.setEnd(body, count);

    startPt.setStart(body, 0);
    startPt.setEnd(body, 0);
    endPt.setStart(body, count);
    endPt.setEnd(body, count);
    highlightText(word, baseNode);

}

function highlightText(word, baseNode)
{
    var retRange = null;
    while(retRange = NEEDLESEARCH_gFinder.Find(word, searchRange, startPt, endPt))
    {

        // check that we have a whole word
        //gSelection.addRange(range);

        // Highlight
        var nodeSurround = baseNode.cloneNode(true);
        var node = highlight(retRange, nodeSurround);
        startPt = node.ownerDocument.createRange();
        startPt.setStart(node, node.childNodes.length);
        startPt.setEnd(node, node.childNodes.length);
    }
}

function highlight(range, node)
{
    var startContainer = range.startContainer;
    var startOffset = range.startOffset;

    var endOffset = range.endOffset;

    var docfrag = range.extractContents();
    var before = startContainer.splitText(startOffset);
    var parent = before.parentNode;
    node.appendChild(docfrag);
    parent.insertBefore(node, before);
    return node;
}


function makefocus() {
goToggleToolbar('needlesearch','viewneedlesearchbar');
    var seaBox = document.getElementById("NeedleSearchSearchTerms");
    var nbar = document.getElementById("needlesearch");

if (nbar.hidden){
	window.frames[0].focus();
}else {
	seaBox.focus();
}

nukeimages();


}

function nukeimages() {

var bundle = document.getElementById('needlesearch_properties');

try {
	NEEDLESEARCH_nsTextOnly = NEEDLESEARCH_nsPref.getCharPref('xImgToggle')
} catch (err) {
	NEEDLESEARCH_nsTextOnly = false
}

try {
	NEEDLESEARCH_nsToolbarHeight = NEEDLESEARCH_nsPref.getCharPref('ToolbarHeight')
} catch (err) {
	NEEDLESEARCH_nsToolbarHeight = '30'
}



if (NEEDLESEARCH_nsTextOnly == "true" ) 
{
//alert ("TEXT ONLY is checked");
eatimage("ShowButton", bundle.getString('ns.noimage_search'));
eatimage("ShowNewTabButton",bundle.getString('ns.noimage_searchnewtab'));
eatimage("ShowNewWindowButton",bundle.getString('ns.noimage_searchnewwin'));

eatimage("HighlightButton",bundle.getString('ns.noimage_highlight'));
eatimage("AutoAddButton",bundle.getString('ns.noimage_autoadd'));
eatimage("EditorButton",bundle.getString('ns.noimage_edit'));
eatimage("NeedleSearchUrlButton",bundle.getString('ns.noimage_needleurl'));
} else {
eattext("ShowButton");
eattext("ShowNewTabButton");
eattext("ShowNewWindowButton");

eattext("HighlightButton");
eattext("AutoAddButton");
eattext("EditorButton");
eattext("NeedleSearchUrlButton");
document.getElementById("needlesearch").height="";

if (!document.getElementById("NeedleSearchUrlButton").image){
	alert (document.getElementById('needlesearch_properties').getString('ns.restart_for_images'));
}
}
}

function imgflip(nem,iftyp,ifval)
{
if (NEEDLESEARCH_nsTextOnly != "true") {
if (document.getElementById("NeedleSearchUrlButton").image){
document.getElementById(nem).setAttribute(iftyp, ifval);
}
}
}

function eatimage(nem,newnem){

document.getElementById(nem).label=newnem;
document.getElementById(nem).image=null;

}

function eattext(nem){
if (document.getElementById(nem).image){
document.getElementById(nem).label=null;
}
}
